void rpsIsr()
{
  rpsCounter ++; //blue wire is +, yellow is -, white is out on hall sensor
}

void rpsSense() { // rps range is 2-38 with low gear 500 interval and 2 *
  const unsigned long interval = 500;
  if (millis() - previousRPSMillis > interval) {
    rps = rpsCounter * 2; // Max RPM is 2400 with low gear and 3240 with high gear minimum is 420
    //Serial.print("  RPM "); Serial.println(rps); Serial.print("  speedFw "); Serial.println(speedFw);
    rpsCounter = 0;
    previousRPSMillis = millis();
  }
  // Blue wire is +, Yellow wire is -,  White is output.  RPS range is 3 to 59 Hz on scope Hall pin
}

void rpsGovenor() {
//  Serial.print("  speedFw ");
//  Serial.println(speedFw);
  const unsigned long throttleInterval = 100;
  int lowT = 1300;
  if (ch2State == true) { //if steering signal from RX is seen, look for throttle signal as well by ch2State = true
    attachInterrupt(digitalPinToInterrupt(32), throttleInterupt, CHANGE);
  }
  else if (millis() - prvThrottleDetachDelay > throttleDetachDelay) {
    detachInterrupt(digitalPinToInterrupt(32));
    prvThrottleDetachDelay = millis();
  }

  if (millis() - previousThrottleUpMillis >= throttleInterval && ch2State == false) {
    //Serial.print(" rpsSetLow is "); Serial.println(rpsSetLow);
    if (rps < (rpsSetLow - 25)) {
      // Serial.println(" speed is low by 25 ");
      speedFw +=  25;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      // Serial.print("  speedFw from -25 low "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }

    if (rps < (rpsSetLow - 12)) {
      // Serial.println(" speed is low by 12 ");
      speedFw += 10;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      // Serial.print("  speedFw from -12 low "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }
    if (rps < rpsSetLow) {
      //              Serial.println(" speed is low ");
      speedFw += 1;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      // Serial.print("  from rpsSetLow by 1 speedFw is "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }
    previousThrottleUpMillis = millis(); // weels start to spin no load at 1580, speedFw needs to be set
  }

  if (millis()  - previousThrottleDnMillis >= throttleInterval && rps > rpsSetHigh && ch2State == false) {
    if (rps > (rpsSetHigh + 25)) {
      //Serial.println(" speed is high by more than 25 ");
      speedFw -= 15;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      //Serial.print(" from rpsSetHigh + 25, speedFw is "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }
    if (rps > (rpsSetHigh + 12)) {
      //Serial.println(" speed is high by less than 25 and more than 12");
      speedFw -= 2;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      //Serial.print("  from rpsSetHigh + 12, speedFw is "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }
    if (rps > rpsSetHigh) {
      //Serial.println(" speed is high by less than 12 ");
      //        Serial.print(time);
      speedFw -= 1;
      speedFw = constrain(speedFw, lowT, 2000);
      throttle.write(speedFw);
      //Serial.print("  from rpsSetHigh + 1, speedFw is "); Serial.print(speedFw); Serial.print("  RPM is "); Serial.println(rps);
    }
    previousThrottleDnMillis = millis();
  }
}

void reverse() 
{
  const unsigned long throttleInterval = 5000;
  int lowT = 750; // was 542 and not working. When gets down to 539, goes to full throttle, 900 measured low from TX, needs a jolt to start, weird
  if (millis()  - previousThrottleDnMillis >= throttleInterval && ch2State == false)
  {

    throttle.write(1580); // needed to get started in reverse, weird
    delay(15); //15 works less not
    throttle.write(1100); //start up reverse speed

//    for (speedFw = 1300; speedFw >= 1170; speedFw -= 2) { //1300 to 1100 slow to fast, no rpm with delays
//      throttle.write(speedFw);
//      Serial.print(" speedFw is "); Serial.println(speedFw);
//      delay(200);
//    }
    
    previousThrottleDnMillis = millis();
  }
}
