#include <Servo.h>
#include <Wire.h>
#include <LSM303.h>
#include <Adafruit_GPS.h>
#include <nmea.h>
#include <LiquidCrystal.h>
#include<SPI.h>
//#include <SD.h>
#include <SdFat.h>
#define GPSSerial Serial3
Adafruit_GPS GPS(&GPSSerial);
Servo steering, throttle, scanservo;
LiquidCrystal lcd(23, 24, 25, 26, 27, 28); // RS,E,D4-D7
LSM303 LSMcompass;
NMEA gps(GPRMC);  // GPS data connection to GPRMC sentence type
SdFat SD;
File myFile;
volatile int rps = 0, rpsCounter = 0;
volatile bool ch2State = false;
bool step45 = false, scanUp = false, scanDn = false, shortDist = false, upRan = false, gpsRan = false, scanUD = true, sonarClear, scanUDRan = false,
runTurn, stopMoveForward;
volatile unsigned long ch1Start, ch1Stop, ch2Start, ch2Stop;
unsigned long previousGPSMillis = 0, previousCompassMillis = 0, previousTurnMillis = 0, previousIRscanSteeringMillis = 0,
              previousForward = 0, previousThrottleDnMillis = 0, previousThrottleUpMillis = 0, previousRPSMillis = 0,
              previousMoveForwardMillis = 0, previousServo = 0, pScanStepMillis = 0, previousLCD = 0, prevScan = 0,
              prvThrottleDetachDelay = 0;

int headDn, headUp, head, a = 63, d = 4000, right1, left1, speedFw = 1570, ch1 = 90, ch2 = 90, rpsSetHigh = 0, rpsSetLow = 0, sonar1,
    pos, max_up, max_dn, posMax, LSMheading, lcdCase = 0, moveForwardInterval = 500, headShort, headAjust;

const int pwPin1 = 11, trigPin1 = 12, compassInterval = 100, gpsInterval = 10000, turnInterval = 15, scanInterval = 4000,
          servoInterval = 250, IRscanSteeringInterval = 250,  scanStepInterval = 25, leftDist = 35, rightDist = 35,
          LCDInterval = 2000, scanUDInterval = 10000, throttleDetachDelay = 25;

long pulse1;
float b = 3.1415926, headingDegrees, e, f, g, dest_latitude = 48.1088174, dest_longitude = 122.245841;
double lat1 = 0, long1 = 0;
unsigned int irhead = 90;
typedef struct {
  float SDdest_latitude;
  float SDdest_longitude;
} waypoints;
waypoints pointArray[120];
char way[980];


void setup() {
  steering.attach(10); // Steering JR DS8411 4.8 to 6.0V  on ch1
  steering.write(90);
  throttle.attach(3); //  Throttle on ch2
  scanservo.attach(44);//  Hitech HS-205BB
  pinMode(pwPin1, INPUT); // pin 11
  pinMode(2, INPUT_PULLUP); // rpm sensor
  attachInterrupt(digitalPinToInterrupt(18), steeringInterupt, CHANGE); // attach chan 1 from RX to pin 18 thru level convertor
  attachInterrupt(digitalPinToInterrupt(2), rpsIsr, RISING); // attach hall sensor white wire to pin 2 thru level convertor
  pinMode(trigPin1, OUTPUT); // pin to sonar scan
  digitalWrite(trigPin1, LOW); //set low at start as high is trigger
  Serial.begin(115200);
  scanservo.write(90);
  Wire.begin(); //needed for LSM303
  lcd.begin(16, 2); // need to specify how many columns and rows are in the LCD unit
  lcd.clear();      // this clears the LCD. You can use this at any time
  LSMcompass.init();
  LSMcompass.enableDefault();
  LSMcompass.m_min = (LSM303::vector<int16_t>) {
    -588, -775, -502
  };
  LSMcompass.m_max = (LSM303::vector<int16_t>) {
    +583, +431, +543
  };

  GPS.begin(9600); // green=rx green/wh=tx orange=vin orange/wh=gnd connect TX to TX
  Serial3.begin(9600);
  //GPS.sendCommand(PMTK_API_SET_FIX_CTL_1HZ);
  //GPS.sendCommand(PMTK_SET_BAUD_115200);
  //delay(1000);
  //GPS.begin(115200);
  //Serial3.begin(115200);
  //GPS.sendCommand(PMTK_API_SET_FIX_CTL_1HZ);
  GPS.sendCommand(PMTK_API_SET_FIX_CTL_200_MILLIHERTZ); //every 5 seconds sends to serial I think
  GPS.sendCommand(PMTK_API_SET_FIX_CTL_1HZ); //Gets position info every 1 sec
  //GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_ALLDATA);
  GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCGGA);
  GPS.sendCommand(PMTK_ENABLE_SBAS);
  GPS.sendCommand(PMTK_ENABLE_WAAS);
  Serial.print("Initializing SD card...");

  if (!SD.begin(52)) {
    Serial.println("initialization failed!");
    while (1);
  }
  Serial.println("initialization done.");
}
